## candy-6.0.4.gh.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.4)

project(candy LANGUAGES C CXX VERSION 6.0.4)

option(CANDY_NOEXE  "Don't build executable")
option(CANDY_DEVEL  "Build development library")
option(CANDY_STATIC "Static linking dependent libraries")

set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)

if (${CANDY_STATIC})
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
    set(CMAKE_SKIP_BUILD_RPATH TRUE)
    set(CANDY_STATIC_OPENSSL 1)
    set(CANDY_STATIC_FMT 1)
    set(CANDY_STATIC_SPDLOG 1)
    set(CANDY_STATIC_POCO 1)
endif()

find_package(PkgConfig REQUIRED)

if (${CANDY_STATIC_OPENSSL})
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/openssl
    )
    execute_process(
        COMMAND ${CMAKE_COMMAND} -DTARGET_OPENSSL=${TARGET_OPENSSL} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/openssl
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/openssl
        RESULT_VARIABLE result
    )
    if(NOT result EQUAL "0")
        message(FATAL_ERROR "OpenSSL CMake failed")
    endif()

    execute_process(
        COMMAND ${CMAKE_COMMAND} --build ${CMAKE_CURRENT_BINARY_DIR}/openssl
        RESULT_VARIABLE result
    )
    if(NOT result EQUAL "0")
        message(FATAL_ERROR "OpenSSL Download or Configure failed")
    endif()

    include(ProcessorCount)
    ProcessorCount(nproc)
    if(nproc EQUAL 0)
        set(nproc 1)
    endif()
    set(OPENSSL_ROOT_DIR ${CMAKE_CURRENT_BINARY_DIR}/openssl/openssl/src/openssl)
    execute_process(
        COMMAND make -j${nproc}
        WORKING_DIRECTORY ${OPENSSL_ROOT_DIR}
        RESULT_VARIABLE result
    )
    if(NOT result EQUAL "0")
        message(FATAL_ERROR "OpenSSL Build failed")
    endif()

    set(OPENSSL_ROOT_DIR ${CMAKE_CURRENT_BINARY_DIR}/openssl/openssl/src/openssl)
    set(OPENSSL_INCLUDE ${OPENSSL_ROOT_DIR}/include)
    set(OPENSSL_LIB_CRYPTO ${OPENSSL_ROOT_DIR}/libcrypto.a)
    set(OPENSSL_LIB_SSL ${OPENSSL_ROOT_DIR}/libssl.a)
    include_directories(${OPENSSL_INCLUDE})
else()
    find_package(OpenSSL REQUIRED)
endif()

if (${CANDY_STATIC_FMT})
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Fetch.cmake)
    Fetch(fmt "https://github.com/fmtlib/fmt.git" "10.2.1")
endif()

if (${CANDY_STATIC_SPDLOG})
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Fetch.cmake)
    Fetch(spdlog "https://github.com/gabime/spdlog.git" "v1.14.1")
else()
    pkg_check_modules(SPDLOG REQUIRED spdlog)
    add_definitions(${SPDLOG_CFLAGS})
    include_directories(${SPDLOG_INCLUDEDIR})
endif()

if (${CANDY_STATIC_POCO})
    set(ENABLE_DATA OFF CACHE BOOL "" FORCE)
    set(ENABLE_DATA_MYSQL OFF CACHE BOOL "" FORCE)
    set(ENABLE_DATA_POSTGRESQL OFF CACHE BOOL "" FORCE)
    set(ENABLE_DATA_SQLITE OFF CACHE BOOL "" FORCE)
    set(ENABLE_DATA_ODBC OFF CACHE BOOL "" FORCE)
    set(ENABLE_MONGODB OFF CACHE BOOL "" FORCE)
    set(ENABLE_REDIS OFF CACHE BOOL "" FORCE)
    set(ENABLE_ENCODINGS OFF CACHE BOOL "" FORCE)
    set(ENABLE_PROMETHEUS OFF CACHE BOOL "" FORCE)
    set(ENABLE_PAGECOMPILER OFF CACHE BOOL "" FORCE)
    set(ENABLE_PAGECOMPILER_FILE2PAGE OFF CACHE BOOL "" FORCE)
    set(ENABLE_ACTIVERECORD OFF CACHE BOOL "" FORCE)
    set(ENABLE_ACTIVERECORD_COMPILER OFF CACHE BOOL "" FORCE)
    set(ENABLE_ZIP OFF CACHE BOOL "" FORCE)
    set(ENABLE_JWT OFF CACHE BOOL "" FORCE)
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Fetch.cmake)
    Fetch(poco "https://github.com/pocoproject/poco.git" "poco-1.13.3-release")
else()
    find_package(Poco REQUIRED COMPONENTS Foundation XML JSON Net NetSSL)
endif()

set(CANDY_EXECUTE_NAME "candy")
set(CANDY_LIBRARY_NAME "libcandy")

add_compile_definitions(CANDY_VERSION="${PROJECT_VERSION}")
add_compile_options("-Wfatal-errors")

include_directories(${PROJECT_SOURCE_DIR}/src)

add_subdirectory(${PROJECT_SOURCE_DIR}/src/ffi)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/main)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/core)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/websocket)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/tun)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/peer)
add_subdirectory(${PROJECT_SOURCE_DIR}/src/utils)

=== cmake/openssl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.4)
cmake_policy(SET CMP0135 NEW)
project(openssl)

include(ExternalProject)
ExternalProject_Add(
    openssl
    PREFIX                      ${CMAKE_CURRENT_BINARY_DIR}/openssl
    URL                         https://www.openssl.org/source/openssl-3.4.0.tar.gz
    LOG_BUILD                   ON
    BUILD_IN_SOURCE             YES
    BUILD_COMMAND               ""
    CONFIGURE_COMMAND           ./config --release no-unit-test no-shared ${TARGET_OPENSSL} CFLAGS=$ENV{CFLAGS} LDFLAGS=$ENV{LDFLAGS}
    INSTALL_COMMAND             ""
    TEST_COMMAND                ""
)

=== src/core/CMakeLists.txt ===
aux_source_directory(. DIR_LIB_SRCS)
add_library(core STATIC ${DIR_LIB_SRCS})

set_target_properties(core PROPERTIES CXX_STANDARD 23)

if (${CANDY_STATIC_FMT})
    target_link_libraries(core PRIVATE fmt::fmt)
else()
    pkg_check_modules(FMT REQUIRED fmt)
    add_definitions(${FMT_CFLAGS})
    include_directories(${FMT_INCLUDEDIR})
    target_link_libraries(core PRIVATE ${FMT_LIBRARIES})
endif()

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(core PRIVATE spdlog::spdlog)
else()
    target_link_libraries(core PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(core PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
endif()

target_link_libraries(core PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

target_link_libraries(core PRIVATE websocket)
target_link_libraries(core PRIVATE tun)
target_link_libraries(core PRIVATE peer)

=== src/ffi/CMakeLists.txt ===
aux_source_directory(. DIR_SRCS)
add_library(${CANDY_LIBRARY_NAME} STATIC ${DIR_SRCS})

set_target_properties(${CANDY_LIBRARY_NAME} PROPERTIES OUTPUT_NAME ${CANDY_EXECUTE_NAME})
set_target_properties(${CANDY_LIBRARY_NAME} PROPERTIES CXX_STANDARD 23)

target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE core)
target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE websocket)
target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE tun)
target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE peer)
target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE utils)

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE spdlog::spdlog)
else()
    target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
endif()

target_link_libraries(${CANDY_LIBRARY_NAME} PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

if (${CANDY_DEVEL})
    install(FILES candy.h DESTINATION include)
    install(TARGETS ${CANDY_LIBRARY_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

=== src/main/CMakeLists.txt ===
aux_source_directory(. DIR_SRCS)
add_executable(${CANDY_EXECUTE_NAME} ${DIR_SRCS})

set_target_properties(${CANDY_EXECUTE_NAME} PROPERTIES CXX_STANDARD 23)

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE spdlog::spdlog)
else()
    target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
endif()

target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE Threads::Threads)

target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE core)
target_link_libraries(${CANDY_EXECUTE_NAME} PRIVATE utils)

if (NOT ${CANDY_NOEXE})
    install(TARGETS ${CANDY_EXECUTE_NAME})
endif()

=== src/peer/CMakeLists.txt ===
aux_source_directory(. DIR_LIB_SRCS)
add_library(peer STATIC ${DIR_LIB_SRCS})

set_target_properties(peer PROPERTIES CXX_STANDARD 23)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_link_libraries(peer PRIVATE ws2_32)
endif()

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(peer PRIVATE spdlog::spdlog)
else()
    target_link_libraries(peer PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(peer PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
else()
    target_link_libraries(peer PRIVATE OpenSSL::SSL OpenSSL::Crypto)
endif()

target_link_libraries(peer PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

=== src/tun/CMakeLists.txt ===
aux_source_directory(. DIR_LIB_SRCS)
add_library(tun STATIC ${DIR_LIB_SRCS})

set_target_properties(tun PROPERTIES CXX_STANDARD 23)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_link_libraries(tun PRIVATE iphlpapi)
    target_link_libraries(tun PRIVATE ws2_32)

    set(WINTUN_VERSION 0.14.1)
    set(WINTUN_ZIP wintun-${WINTUN_VERSION}.zip)
    set(WINTUN_URL https://www.wintun.net/builds/${WINTUN_ZIP})

    if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${WINTUN_ZIP})
        file(DOWNLOAD ${WINTUN_URL} ${CMAKE_CURRENT_BINARY_DIR}/${WINTUN_ZIP} STATUS DOWNLOAD_STATUS)
        list(GET DOWNLOAD_STATUS 0 STATUS_CODE)
        list(GET DOWNLOAD_STATUS 1 ERROR_MESSAGE)

        if(${STATUS_CODE} EQUAL 0)
            message(STATUS "wintun download success")
        else()
            message(FATAL_ERROR "wintun download failed: ${ERROR_MESSAGE}")
        endif()
    else()
        message(STATUS "use wintun cache")
    endif()

    file(ARCHIVE_EXTRACT INPUT ${CMAKE_CURRENT_BINARY_DIR}/${WINTUN_ZIP})

    include_directories(${CMAKE_CURRENT_BINARY_DIR}/wintun/include)
endif()

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(tun PRIVATE spdlog::spdlog)
else()
    target_link_libraries(tun PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(tun PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
endif()

target_link_libraries(tun PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

=== src/utils/CMakeLists.txt ===
aux_source_directory(. DIR_LIB_SRCS)
add_library(utils STATIC ${DIR_LIB_SRCS})

set_target_properties(utils PROPERTIES CXX_STANDARD 23)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_link_libraries(utils PRIVATE ws2_32)
endif()

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(utils PRIVATE spdlog::spdlog)
else()
    target_link_libraries(utils PRIVATE ${SPDLOG_LIBRARIES})
endif()

target_link_libraries(utils PRIVATE Poco::Foundation Poco::Net)

=== src/websocket/CMakeLists.txt ===
aux_source_directory(. DIR_LIB_SRCS)
add_library(websocket STATIC ${DIR_LIB_SRCS})

set_target_properties(websocket PROPERTIES CXX_STANDARD 23)

if (${CANDY_STATIC_SPDLOG})
    target_link_libraries(websocket PRIVATE spdlog::spdlog)
else()
    target_link_libraries(websocket PRIVATE ${SPDLOG_LIBRARIES})
endif()

if (${CANDY_STATIC_OPENSSL})
    target_link_libraries(websocket PRIVATE ${OPENSSL_LIB_CRYPTO} ${OPENSSL_LIB_SSL})
endif()

target_link_libraries(websocket PRIVATE Poco::Foundation Poco::Net Poco::NetSSL)

=== package/debian/control ===
Source: candy
Section: net
Priority: optional
Maintainer: YangMame <yangmame@icloud.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkg-config,
 libssl-dev,
 libpoco-dev,
 libpcre2-dev,
 libfmt-dev,
 libspdlog-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/lanthora/candy
Vcs-Git: https://github.com/lanthora/candy.git

Package: candy
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: A simple networking tool
